#include <stdio.h>
#include <motelib/system.h>
#include <motelib/uart.h>
#include <motelib/radio.h>
#include <motelib/led.h>
#include <motelib/timer.h>
#include <motelib/button.h>
uint8_t sent;
uint8_t addr = 1;
uint8_t time_s = 0;
int wait = -1;
uint8_t check_send = 0,is_alarm=0,do_sound=0;

Timer   t;
Timer   t2;
char buf[6] , clock_time[6];
int hr_alarm=0,min_alarm=0,sec_alarm=0,SET=0;
int hr_time=0,min_time=0,sec_time=-1;
void receive(Address src, MessageType type, void *msg, uint8_t len)
{
    if (type == 99)
    {
        uint8_t result = ((char*)msg)[0];
	if(result == 1){
        	printf("received %d from NODE# %d\r\n", result, src);
		is_alarm = 1;
    	}
	if(result == 2){
        	printf("received %d from NODE# %d\r\n", result, src);
		is_alarm = 1;
    	}
    }
	
}




void checkButton(ButtonStatus status){
	if(status == BUTTON_PRESSED){
		sent = 1;
		if(check_send == 0 && is_alarm == 1){
			radioRequestTx((addr+1),99,&sent,sizeof(sent),NULL);	
			printf("time count : %d \r\n",wait);
			check_send =1;

		}
		//timerStop(&t);	
	}
	/*if(status == BUTTON_RELEASED){
		printf("time count : %d \r\n",time_s);
	}*/
}
void count_time(){
	if(SET==2){
		sec_time++;
		if(sec_time>=60){
			min_time++;
			sec_time = 0;
			if(min_time>=60){
				hr_time++;
				min_time=0;
				if(hr_time>=24){
					hr_time=0;	
				}
			}
		}	
		printf("%d:%d:%d\r\n",hr_time,min_time,sec_time);
		if( /*(wait>=0 && wait < 10) ||*/ (check_send == 0 && is_alarm == 1) || (hr_time == hr_alarm && min_time == min_alarm && sec_time == sec_alarm)){
			//ledSetValue(4);
		 	//do_sound=1;
			printf("TID TID \r\n");
			wait++;
			is_alarm = 1;
		}
		else{
			wait = -1; 
			//ledSetValue(0);
			
			ledSetValue(0);
			is_alarm = 0;
			check_send = 0;
		}
	}

}
void toggle(){
	//printf("is alarm : %d\r\n",is_alarm);
	if(is_alarm){
	
		if(do_sound){
			ledSetValue(0);
			do_sound=0;
		}
		else{
			ledSetValue(4);
			do_sound=1;
		}
	}
}
void clock(){
	time_s = 0;
	timerCreate(&t);
	timerCreate(&t2);
	timerStart(&t, TIMER_PERIODIC, 1000, count_time);
	timerStart(&t2, TIMER_PERIODIC, 200, toggle);
}

//void clock(){
	//printf("kukkk : %s \r\n", buf );		
//}
void convertToAlarm(){
	int a = buf[0]-'0';
	int b = buf[1]-'0';
	hr_alarm = a*10+b;
	a = buf[3]-'0';
	b = buf[4]-'0';
	min_alarm = a*10+b;
	printf("Alarm at %d:%d:%d\r\n",hr_alarm,min_alarm,sec_alarm);
}
void convertToTime(){
	int a = clock_time[0]-'0';
	int b = clock_time[1]-'0';
	hr_time = a*10+b;
	a = clock_time[3]-'0';
	b = clock_time[4]-'0';
	min_time = a*10+b;
	printf("Time is %d:%d:%d\r\n",hr_time,min_time,(sec_time+1));
}

void clockTimeReady(uint8_t mf);

void bufReady(uint8_t mf) {
	uartRead(buf, sizeof(buf)-1);
	clock_time[sizeof(clock_time)-1] = '\0';
	printf("%s\r\n", buf);
	convertToAlarm();

	printf("Time [XX:XX] : ");

	uartWatchInputBytes(sizeof(clock_time)-1, clockTimeReady);
}

void clockTimeReady(uint8_t mf) {
	uartRead(clock_time, sizeof(clock_time)-1);
	clock_time[sizeof(clock_time)-1] = '\0';
	printf("%s\r\n", clock_time);
	convertToTime();	

	SET = 2;
}

void dataReady(uint8_t markerFound)
{
	//printf("Time : ");	
	uartRead(buf, sizeof(buf));
	printf("%s\r\n",buf);	
	convertToAlarm();
//	SET=1;
	printf("Time [XX:XX] : ");
	//uartWatchInputBytes(sizeof(clock_time), dataReady);
	//if(SET){
	uartRead(clock_time, sizeof(clock_time));
	printf("%s\r\n",clock_time);	
	SET=2;
	convertToTime();//}
	//convertToTime();
}
/*void dataReady2(uint8_t markerFound)
{
	//printf("Time : ");	
	//uartRead(buf, sizeof(buf));
	//printf("%s\r\n",buf);	
	//convertToAlarm();
	//SET=1;
	//printf("Time [XX:XX] : ");
	//uartWatchInputBytes(sizeof(clock_time), dataReady);
	uartRead(clock_time, sizeof(clock_time));
	printf("%s\r\n",clock_time);	
	SET=2;
	convertToTime();
	//convertToTime();
}*/
void show_Initial(){
	printf("Set Alarm Clock [XX:XX] : ");
}
void boot(){
	//convertToTime();	
	uartEnable(true,true);
	show_Initial();
	uartWatchInputBytes(sizeof(buf)-1, bufReady);
	//SET=1;	
	//if(SET)
	//	uartWatchInputBytes(sizeof(clock_time), dataReady);
	//clock();
	radioSetRxHandler(receive);
	buttonSetHandler(checkButton);
	clock();
}





